<template>
    <div
        v-if="pageReady"
        class="w-full"
    >
        <div
            class="px-4 py-2 flex flex-col gap-2"
        >
            <navigation-bar />
            <credit-balance-box
                :credit-id="1"
            />
            <div
                class="border-b border-gray-400 pt-2 mb-2"
            />
            <div>
                <form-select
                    v-model="network"
                    :options="[
                        {value: 'bep20', text: 'BEP20'},
                        {value: 'trc20', text: 'TRC20'},
                    ]"
                    name="network"
                    dark
                    size="lg"
                />
            </div>
            <template
                v-if="network === 'bep20'"
            >
                <div>
                    <div class="pl-2 font-black">{{ computedTransferTitle }}</div>
                    <div
                        class="my-2 flex justify-center"
                    >
                        <div
                            class="input-box flex justify-center items-center"
                        >
                            <qrcode-vue
                                level="H"
                                :size="320"
                                :value="paymentAddress"
                            />
                        </div>
                    </div>
                    <div
                        class="my-4 relative"
                    >
                        <div
                            class="input-box !pr-12"
                        >
                            <div
                                class="w-full overflow-x-hidden text-ellipsis"
                            >
                                {{ paymentAddress }}
                            </div>
                        </div>
                        <div
                            class="cursor-pointer absolute inset-y-0 right-0 flex items-center"
                            @click="onCopyPaymentAddress"
                        >
                            <div
                                class="px-2 mr-[1px] bg-gray-700 text-white w-12 h-12 rounded-tr-lg rounded-br-lg flex items-center text-center"
                            >
                                <font-awesome-icon
                                    icon="fa-solid fa-copy"
                                    size="2x"
                                />
                            </div>
                        </div>
                    </div>
                </div>
            </template>
            <template
                v-else-if="network === 'trc20'"
            >
                <div>
                    <div class="pl-2 font-black">{{ computedTransferTitle }}</div>
                    <div
                        class="my-2 flex justify-center"
                    >
                        <div
                            class="input-box flex justify-center items-center"
                        >
                            <qrcode-vue
                                level="H"
                                :size="320"
                                :value="paymentAddress"
                            />
                        </div>
                    </div>
                    <div
                        class="my-4 relative"
                    >
                        <div
                            class="input-box !pr-12"
                        >
                            <div
                                class="w-full overflow-x-hidden text-ellipsis"
                            >
                                {{ paymentAddress }}
                            </div>
                        </div>
                        <div
                            class="cursor-pointer absolute inset-y-0 right-0 flex items-center"
                            @click="onCopyPaymentAddress"
                        >
                            <div
                                class="px-2 mr-[1px] bg-gray-700 text-white w-12 h-12 rounded-tr-lg rounded-br-lg flex items-center text-center"
                            >
                                <font-awesome-icon
                                    icon="fa-solid fa-copy"
                                    size="2x"
                                />
                            </div>
                        </div>
                    </div>
                </div>
            </template>
            <div
                v-if="network"
            >
                <auto-form
                    ref="form"
                    :fields="formFields"
                />
                <auto-button
                    :block="true"
                    :busy="form && form.busy ? form.busy : false"
                    :disabled="form && form.busy ? form.busy : false"
                    class="tracking-wider uppercase text-2xl"
                    @click="submitForm"
                >
                    {{ $t('submit') }}
                </auto-button>
            </div>
            <div
                class="border-b border-gray-400 pt-2 mb-2"
            />
            <div>
                <div class="pl-2 font-black">{{ $t('top_up_history') }}</div>
            </div>
            <div
                v-if="topupRecords && topupRecords.length"
                class="mb-6 flex flex-col space-y-2"
            >
                <div
                    v-for="topup in topupRecords"
                    :key="topup.id"
                    class="border-2 border-white rounded-lg px-2 py-4"
                >
                    <div
                        class="flex justify-between items-center space-x-2"
                    >
                        <div
                            class="text-2xl font-black"
                        >
                            {{ topup.order_number }}
                        </div>
                        <div>
                            {{ topup.status_explained }}
                        </div>
                    </div>
                    <div>
                        <div class="leading-tight font-mono">
                            {{ topup.from_crypto_symbol }} {{ $helper.fundFormat(topup.topup_amount) }}
                        </div>
                        <div class="leading-tight break-all">
                            <span class="capitalize">{{ $t('address') }}: </span><br>
                            {{ topup.to_crypto_address }}
                        </div>
                    </div>
                    <div
                        class="flex justify-end"
                    >
                        <a
                            href="javascript:"
                            class="text-sm text-blue-400 underline capitalize"
                            @click="viewReceipt = topup.receipt"
                        >
                            {{ $t('view_receipt') }}
                        </a>
                    </div>
                </div>
            </div>
            <div
                v-else
                class="px-4 text-xs"
            >
                {{ $t('no_top_up_history') }}.
            </div>
        </div>
        <panel-modal
            v-if="viewReceipt"
            @close="viewReceipt = null"
        >
            <template
                #body
            >
                <img
                    :src="viewReceipt"
                    class="flex justify-center max-w-full"
                />
            </template>
        </panel-modal>
    </div>
</template>

<script setup>
import {computed, inject, nextTick, onMounted, ref, watch} from "vue";
import CreditBalanceBox from '~/components/credit/balance-box.vue';
import {useUserStore} from "~/stores/user.js";
import NavigationBar from "./navigation-bar.vue";
import {useSettingStore} from "~/stores/setting.js";
import {useI18n} from "vue-i18n";
import QrcodeVue from 'qrcode.vue';
import {FontAwesomeIcon} from "@fortawesome/vue-fontawesome";
import AutoForm from "~/components/auto-form.vue";
import AutoButton from "!/admin/components/button/auto-button.vue";
import axios from "axios";
import PanelModal from "~/components/panel-modal.vue";
import FormSelect from "!/admin/components/form/form-select.vue";

const pageReady = ref(false);
const $helper = inject('$helper');
const $userStore = useUserStore();
const $settingStore = useSettingStore();
const i18n = useI18n();

const topupRecords = ref([]);
const viewReceipt = ref(null);

const network = ref();
const form = ref();
const formFields = computed(() => {
    return [
        {
            type: 'text',
            name: 'amount',
            label: i18n.t('credit_1_topup_amount'),
            note: i18n.t('usdt_1_equal_to_x_credit_1'),
            dollarSign: true,
            dark: true,
            size: 'lg',
            fund: true,
        },
        {
            type: 'text',
            name: 'transaction_id',
            label: i18n.t('transaction_hash'),
            dark: true,
            size: 'lg',
        },
        {
            type: 'file',
            accept: 'image/*',
            name: 'receipt',
            label: i18n.t('receipt'),
            note: i18n.t('please_upload_receipt_after_successfully_transfer'),
        }
    ];
});

const paymentAddress = computed(() => {
    if (!network.value) return '';
    return $settingStore.settings.settings.find(r => {
        return r.setting === `company_${network.value}_usdt_address`;
    }).setting_value || '';
});

const computedTransferTitle = computed(() => {
    return String(i18n.t(`to_topup_please_transfer_usdt_to_below_${network.value}_address`));
});

onMounted(async () => {
    await $userStore.fetchAccount();
    await $settingStore.fetchSettings();
    await loadHistory();

    pageReady.value = true;
});

const onCopyPaymentAddress = async () => {
    await $helper.copyText(paymentAddress.value, () => {
        $helper.alertSuccess({
            message: i18n.t('successfully_copied')
        });
    });
};

const loadHistory = async () => {
    try {
        const data = await axios.post('/credit/c1/topup/load_history');

        topupRecords.value = data.models;
    } catch (e) {
        console.log(e);
    }
}

watch(network, async (newValue) => {
    if (newValue) {
        await nextTick(() => {
            form.value.setValue({name: 'network', value: newValue});
        });
    }
});

const submitForm = async () => {
    try {
        const data = await form.value.submitForm('/credit/c1/topup/submit_form');

        await $helper.alertSuccess({
            message: data.message,
            callback: async () => {
                pageReady.value = false;
                await loadHistory();
                await nextTick(() => {
                    network.value = '';
                    pageReady.value = true;
                });
            }
        })
    } catch (e) {
        console.log(e);
    }
}
</script>
